package adf.sample.view.ctx.handler;

import adf.sample.view.bean.EmployeesBackingBean;

import javax.el.ELContext;
import javax.el.ExpressionFactory;
import javax.el.ValueExpression;

import javax.faces.application.Application;
import javax.faces.context.FacesContext;

import oracle.adf.view.faces.bi.event.ClickEvent;

import oracle.dss.dataView.DataComponentHandle;

import oracle.jbo.Key;

public class ContextualEventHandler {
    public ContextualEventHandler() {
        super();
    }
    
  /**
   * handle the event and receive the payload object. The payload object is of
   * the event type raising the contextual event, for example a JSF value change 
   * event or action event, or an ADF binding event. For the DVT component in 
   * this hands-on it is the click event
   * @param payload
   */
  public void handleEvent(Object payload){
      ClickEvent clickEvent = (ClickEvent) payload;
      if (clickEvent.getComponentHandle() instanceof DataComponentHandle){
          DataComponentHandle dch = (DataComponentHandle) clickEvent.getComponentHandle();          
          //get the selected row key from the graph (click event)
          Key rwKey = (Key) dch.getValue(DataComponentHandle.ROW_KEY);
          EmployeesBackingBean employeesBean = getEmployeesBean();
          employeesBean.reQueryEmployeestable((oracle.jbo.domain.Number)rwKey.getKeyValues()[0]);
      }        
  }
  
  private EmployeesBackingBean getEmployeesBean() {
      FacesContext fctx = FacesContext.getCurrentInstance();
      ELContext elctx = fctx.getELContext();
      Application app = fctx.getApplication();
      ExpressionFactory exprFactory = app.getExpressionFactory();
      ValueExpression ve = null;
      //access the backing bean, which is configured in backing bean scope
      //in the employees task flow.
      ve = exprFactory.createValueExpression( 
            elctx,               
            "#{backingBeanScope.employeesBackingBean}",
             Object.class);  
      return (EmployeesBackingBean) ve.getValue(elctx);
  }
    
}
